﻿using System;
using System.ComponentModel.DataAnnotations;
using MRGSP.SurveyMaster.Core.Service;
using MRGSP.SurveyMaster.Localization;

namespace MRGSP.SurveyMaster.Infra
{
    [AttributeUsage(AttributeTargets.Field | AttributeTargets.Property, AllowMultiple = false, Inherited = true)]
    public sealed class LoginUniqueAttribute : ValidationAttribute
    {
        private static readonly string DefaultErrorMessage = MUI.login_unique;

        public LoginUniqueAttribute()
            : base(DefaultErrorMessage)
        {
        }

        public override string FormatErrorMessage(string name)
        {
            return DefaultErrorMessage;
        }

        public override bool IsValid(object value)
        {
            if (string.IsNullOrEmpty((string)value)) return true;
            return !IoC.Resolve<IUserService>().Exists((string) value);
        }
    }
}