﻿using System.Linq;
using System.Web.Mvc;
using MRGSP.SurveyMaster.Core.Service;
using Omu.ValueInjecter;

namespace MRGSP.SurveyMaster.Infra.ValueInjections
{
    public class ChildTypesInjection : NoSourceValueInjection
    {
        readonly string prefix;

        public ChildTypesInjection(string prefix)
        {
            this.prefix = prefix;
        }

        protected override void Inject(object target)
        {
            var targetProps = target.GetProps();

            for (var i = 0; i < targetProps.Count; i++)
            {
                var currentTarget = targetProps.GetByName(prefix + "Type");

                if(currentTarget == null || currentTarget.PropertyType != typeof(object)) continue;

                var value = IoC.Resolve<IControlTypeService>().GetChildTypes().Select(o =>
                                                                                      new SelectListItem
                                                                                          {
                                                                                              Text = o.Name,
                                                                                              Value = o.Id.ToString()
                                                                                          });
                currentTarget.SetValue(target, value);

            }
        }
    }
}