﻿using System.Linq;
using System.Text;
using MRGSP.SurveyMaster.Core.Model;
using MRGSP.SurveyMaster.Core.Service.Utils;

namespace MRGSP.SurveyMaster.Service.Utils
{
    public class GridCellListBuilder : IQuestionBuilder
    {
        public string Build(Question q)
        {
            var s = new StringBuilder();

            s.Append(QuestionBuilder.Build(q));

            if (q.Children.Count() > 0)
            {
                s.Append("<ul>");
                var x = "";
                x = q.Children.Aggregate(x, (current, child) 
                                            => current + ("<li>" + QuestionBuilder.Get(child.Type).Build(child) + "</li>"));
                s.Append(x);
                s.Append("</ul>");
            }
            return s.ToString();
        }
    }
}