﻿using System.Linq;
using System.Text;
using MRGSP.SurveyMaster.Core.Model;
using MRGSP.SurveyMaster.Core.Service.Utils;

namespace MRGSP.SurveyMaster.Service.Utils
{
    public class ListCreateBuilder : IQuestionBuilder
    {
        public string Build(Question q)
        {
            var s = new StringBuilder();
            s.Append(
                string.Format(
                    @"<div id='qwrap{0}' class='{4}' ><div id='util{0}' class='util'>{1}{2}{3}</div>",
                          q.Id,
                          LinkBuilder.Build(LinkType.Add, "addQuestion", q.Id),
                          LinkBuilder.Build(LinkType.Edit, "editQuestion", q.Id),
                          LinkBuilder.Build(LinkType.Remove, "deleteQuestion", q.Id),
                          q.Type
                          ));

            s.Append(string.Format("{0}",
                HtmlGeneratorFactory.Get(q.Type).Generate(q)));

            if (q.Children.Count() > 0)
            {
                s.Append("<ul>");
                var x = "";
                x = q.Children.Aggregate(x, (current, child)
                    => current + ("<li>" + QuestionCreateBuilder.Get(child.Type).Build(child) + "</li>"));
                s.Append(x);
                s.Append("</ul>");
            }
            s.Append("</div>");

            return s.ToString();
        }
    }
}