﻿using System.Collections.Generic;
using System.Linq;
using MRGSP.SurveyMaster.Core.Model;
using MRGSP.SurveyMaster.Core.Service.Utils;

namespace MRGSP.SurveyMaster.Service.Utils
{
    public class TextBoxReader : IValueReader
    {
        public IEnumerable<Answer> Read(Question question, IDictionary<string, string> f)
        {
            var value = f["q" + question.Id].Trim();
            if (value.Length > 0)
                yield return new Answer { QuestionId = question.Id, Value = f["q" + question.Id] };

            foreach (var q in question.Children.SelectMany(child => ValueReaderFactory.Get(child.Type).Read(child, f)))
            {
                yield return q;
            }
        }
    }
}